#include <xtl.h>
#include <stdio.h>
#include <string.h>
#include "kernel.h"
#include "types.h"

//XamContentOpenFile(userflagmask,mntdev,imgpath, perm? ,? ,? , xoverlapped)
#define XAMCONTENTOPENFILE_ORD (u32)0x269
u32 (*XamContentOpenFile)(u32, char*, char*,u32,u32,u32,u32*);//last 3 u32 are things like xoverlapped ptrs

// XamContentClose(pathtooriginalmapping,xoverlapped)
#define XAMCONTENTCLOSE_ORD (u32)0x25a
u32 (*XamContentClose)(char*,u32*);

BOOL fileExists(PCHAR path)
{
	HANDLE file = CreateFile(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(file == INVALID_HANDLE_VALUE)
	{
		DWORD err = GetLastError();
		if(err != 5)// access denied, it exists we just couldn't get a handle to it
			return FALSE;
	}
	CloseHandle(file);
	return TRUE;
}

// gets the path of a symbolic link
void getPath(char* path, char* outstr)
{
	NTSTATUS retsts;
	HANDLE objHandle;
	OBJECT_ATTRIBUTES oob;
	ULONG retlen;
	STRING unistr = {255,256,outstr};
	STRING oStr = MAKE_STRING(path);
	InitializeObjectAttributes(&oob, &oStr, OBJ_CASE_INSENSITIVE, 0);
	memset(outstr, 0x0, 256);
	retsts = NtOpenSymbolicLinkObject(&objHandle, &oob);
	if(retsts == 0)
	{
		retsts = NtQuerySymbolicLinkObject(objHandle, &unistr, &retlen);
	}
	CloseHandle(objHandle);
}

HRESULT deleteLink(const char* szDrive, const char* sysStr)
{
	CHAR szDestinationDrive[MAX_PATH];
	sprintf_s(szDestinationDrive, MAX_PATH, sysStr, szDrive);
	STRING LinkName = MAKE_STRING(szDestinationDrive);
	return ObDeleteSymbolicLink(&LinkName);
}

HRESULT mountPath(const char* szDrive, const char* szDevice, const char* sysStr)
{
	CHAR szDestinationDrive[MAX_PATH];
	sprintf_s(szDestinationDrive, MAX_PATH, sysStr, szDrive);
	STRING DeviceName = MAKE_STRING(szDevice);
	STRING LinkName = MAKE_STRING(szDestinationDrive);
	ObDeleteSymbolicLink(&LinkName);
	return (HRESULT)ObCreateSymbolicLink(&LinkName, &DeviceName);
}

HRESULT mount(const char* szDrive, const char* szDevice)
{
	if(KeGetCurrentProcessType() == SYSTEM_PROC)
		return mountPath(szDrive, szDevice, SYS_STRING);
	else
		return mountPath(szDrive, szDevice, USR_STRING);
}

u32 resolveFunct(char* modname, u32 ord)
{
	UINT32 ptr32=0, ret=0, ptr2=0;
	ret = XexGetModuleHandle(modname, &ptr32); //xboxkrnl.exe xam.dll?
	if(ret == 0)
	{
		ret = XexGetProcedureAddress(ptr32, ord, &ptr2 );
		if(ptr2 != 0)
			return ptr2;
	}
	return 0; // function not found
}

// returns 0 on success, creates symbolic link on it's own to the new szDrive
u32 mountCon(CHAR* szDrive, CHAR* szDevice, CHAR* szPath)
{
	u32 ret;
	CHAR szMountPath[MAX_PATH];
	if(XamContentOpenFile == 0)
	{
		ret = resolveFunct("xam.xex", XAMCONTENTOPENFILE_ORD); 
		XamContentOpenFile = (u32 (__cdecl *)(u32, char*, char*,u32,u32,u32,u32*))ret;
		if(XamContentOpenFile == 0)
			return ERROR_INVALID_HANDLE; // well, invalid handle good enough for me...
	}
	sprintf_s(szMountPath,MAX_PATH,"\\??\\%s\\%s", szDevice, szPath);
	return XamContentOpenFile(0xFE, szDrive, szMountPath, 0x4000043,0,0,0);
}

// returns 0 on success, destroys symbolic link as well
u32 unmountCon(CHAR* szDrive)
{
	u32 ret;
	CHAR szMountPath[MAX_PATH];
	if(XamContentClose == 0)
	{
		ret = resolveFunct("xam.xex", XAMCONTENTCLOSE_ORD);
		XamContentClose = (u32 (__cdecl *)(char *,u32 *))ret;
		if(XamContentClose == 0)
			return ERROR_INVALID_HANDLE;
	}
	sprintf_s(szMountPath,MAX_PATH,"\\??\\%s",szDrive);
	return  XamContentClose(szMountPath,0);
}

VOID patchInJump(u32* addr, u32 dest, BOOL linked)
{
	if(dest & 0x8000) // If bit 16 is 1
		addr[0] = 0x3D600000 + (((dest >> 16) & 0xFFFF) + 1); // lis 	%r11, dest>>16 + 1
	else
		addr[0] = 0x3D600000 + ((dest >> 16) & 0xFFFF); // lis 	%r11, dest>>16

	addr[1] = 0x396B0000 + (dest & 0xFFFF); // addi	%r11, %r11, dest&0xFFFF
	addr[2] = 0x7D6903A6; // mtctr	%r11

	if(linked)
		addr[3] = 0x4E800421; // bctrl
	else
		addr[3] = 0x4E800420; // bctr
	__dcbst(0, addr);
	__sync();
}

DWORD HookOrd(DWORD ord, DWORD dstFun, PHV_IMAGE_EXPORT_TABLE expbase)
{
	DWORD modOffset = (expbase->ImageBaseAddress)<<16;
	DWORD origOffset = (expbase->ordOffset[ord-1])+modOffset;
	expbase->ordOffset[ord-1] = dstFun-modOffset;
	__dcbst(0, &expbase->ordOffset[ord-1]);
	__sync();
	return origOffset;
}